Name:           dansguardian
Version:        2.10.1.1
Release:        15%{?dist}
Summary:        Content filtering web proxy
Summary(de):    Contentfilter-Proxy

Group:          System Environment/Daemons
# upstream dual-licenses this with GPLv2+ and an own license
# for us GPLv2+ applies as stated on http://dansguardian.org/?page=copyright2
# citation:
#    freely (no cost) downloadable from this site for general purpose unix
#    distributions like FreeBSD, Debian, Fedora, Ubuntu, etc
License:        GPLv2+
URL:            http://www.dansguardian.org/
Source0:        http://dansguardian.org/downloads/2/Stable/%{name}-%{version}.tar.gz
Source1:        dansguardian.service
Source2:        dansguardian.httpd
Source3:        dansguardian.logrotate
# ClamAV integration
Source4:        dansguardian-clamd.conf
Source5:        dansguardian-clamd.service
Source6:        dansguardian-clamd.sysconfig
# This patch removes the upstream restrictions on the GPLv2+ source
Patch0:         dansguardian-copyright-notice.patch
# Fixes some compilation errors with gcc 4.4
Patch1:         dansguardian-gcc44.patch
# Adds support for ClamAV > 0.95
Patch2:         dansguardian-clamav095.patch
# Fix some typos ;) (Bug #515363)
Patch3:         dansguardian-must-be-successful.patch
# Remove check for clamav version
Patch4:         dansguardian-2.10.1.1-Do-no-check-for-clamav-version.patch
# g++-4.7 does not provide sizeof() by default
Patch5:         dansguardian-2.10.1.1-Include-stddef.h-for-offsetof.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:   clamav-devel pcre-devel zlib-devel
BuildRequires:   pkgconfig
# For Do-no-check-for-clamav-version patch
BuildRequires:   autoconf
# For %%_unitdir
BuildRequires:   systemd-units
Requires(pre):   shadow-utils
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
# For triggerun
Requires(post): systemd-sysv
Requires:       clamav-server


%description
DansGuardian filters the content of pages based on many methods including
phrase matching, PICS filtering and URL filtering. It does not purely filter
based on a banned list of sites.

It provides real-time virus scanning capabilities for content access.

DansGuardian is designed to be completely flexible and allows you to tailor the
filtering to your exact needs. It can be as draconian or as unobstructive as
you want. The default settings are geared towards what a primary school might
want but DansGuardian puts you in control of what you want to block.

DansGuardian requires squid or another similar caching proxy server on your
local network.

%description -l de
DansGuardian filtert den Content einer Webseite basierend auf verschiedenen
Methoden wie beispielsweise Wortfilter, PICS filtering und URL filtering. Es
handelt sich also um ein echtes Content filtering anstatt einfacher Blacklists.

Außerdem bietet DansGuardian die Möglichkeit einen Virenfilter einzubinden.

DansGuardian wurde darauf ausgelegt so flexibel wie möglich zu sein und
erlaubt es die Filterregeln exakt auf die eigenen Bedürfnisse anzupassen.
Vorgegeben sind Einstellungen die dem Bedarf einer Grundschule entsprechen.

DansGuardian benötigt squid oder einen ähnlichen Caching-Proxy-Server im
lokalen Netzwerk.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
autoconf

%build
%configure \
   --enable-clamav \
   --enable-clamd \
   --enable-icap \
   --enable-kavd \
   --enable-commandline \
   --enable-trickledm \
   --enable-ntlm \
   --enable-email \
   --with-proxyuser=dansguardian \
   --with-proxygroup=dansguardian

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
install -Dpm 644 %{SOURCE3} \
    $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}
# delete the other scripts since they are of no use for Fedora users
rm -rf $RPM_BUILD_ROOT%{_datadir}/%{name}/scripts
chmod 755 $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}.pl

# install init script and httpd config
install -Dpm 644 %{SOURCE1} $RPM_BUILD_ROOT%{_unitdir}/%{name}.service
install -Dp -m0644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/%{name}.conf

# we'll install this later within %doc
rm -rf $RPM_BUILD_ROOT%{_datadir}/doc/%{name}

# create the log dir
install -dm 755 $RPM_BUILD_ROOT%{_localstatedir}/log/%{name}

# for clamav integration
install -dm 700 $RPM_BUILD_ROOT%{_localstatedir}/run/%{name}
touch $RPM_BUILD_ROOT%{_localstatedir}/run/%{name}/clamd.sock
( cd $RPM_BUILD_ROOT%{_sbindir} && ln -s clamd clamd.%{name} )
install -m644 %{SOURCE5} $RPM_BUILD_ROOT%{_unitdir}/clamd.%{name}.service
install -dm755 $RPM_BUILD_ROOT%{_sysconfdir}/clamd.d
install -m644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/clamd.d/%{name}.conf
install -dm755 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m644 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/clamd.%{name}

%clean
rm -rf $RPM_BUILD_ROOT


%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || \
useradd -r -g %{name} -d %{_datadir}/%{name} -s /sbin/nologin \
   -c "DansGuardian web content filter" %{name}
exit 0

# in the first release we put some user-editable files inside the datadir. doh!
# if they are still there we migrate them over to their new home in the
# sysconfdir.
if [ "$1" -gt 1 ] ; then
    if [ -e %{_datadir}/%{name}/lists ] ; then
        mv -f %{_datadir}/%{name}/lists %{_sysconfdir}/%{name}
    fi
fi

%post
if [ $1 -eq 1 ] ; then 
    # Initial installation 
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%preun
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable dansguardian.service > /dev/null 2>&1 || :
    /bin/systemctl stop dansguardian.service > /dev/null 2>&1 || :
    /bin/systemctl --no-reload disable clamd.dansguardian.service > /dev/null 2>&1 || :
    /bin/systemctl stop clamd.dansguardian.service > /dev/null 2>&1 || :
fi


%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
    /bin/systemctl try-restart clamd.dansguardian.service >/dev/null 2>&1 || :
    /bin/systemctl try-restart dansguardian.service >/dev/null 2>&1 || :
fi

%triggerun -- dansguardian < 2.10.1.1-9
# Save the current service runlevel info
# User must manually run systemd-sysv-convert --apply dansguardian
# and systemd-sysv-convert --apply clamd.dansguardian
# to migrate them to systemd targets
/usr/bin/systemd-sysv-convert --save dansguardian >/dev/null 2>&1 ||:
/usr/bin/systemd-sysv-convert --save clamd.dansguardian >/dev/null 2>&1 ||:

# Run these because the SysV package being removed won't do them
/sbin/chkconfig --del dansguardian >/dev/null 2>&1 || :
/sbin/chkconfig --del clamd.dansguardian >/dev/null 2>&1 || :
/bin/systemctl try-restart clamd.dansguardian.service >/dev/null 2>&1 || :
/bin/systemctl try-restart dansguardian.service >/dev/null 2>&1 || :


%files
%defattr(-,root,root,-)
%doc COPYING INSTALL README UPGRADING
%doc doc/AuthPlugins doc/ContentScanners doc/DownloadManagers doc/FAQ
%doc doc/FAQ.html doc/Plugins
%doc %{_mandir}/man8/%{name}.8.gz
%{_sbindir}/%{name}
%attr(-,%{name},%{name}) %{_datadir}/%{name}
%{_unitdir}/%{name}.service
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}*.conf
%dir %{_sysconfdir}/%{name}/authplugins
%config(noreplace) %{_sysconfdir}/%{name}/authplugins/*
%dir %{_sysconfdir}/%{name}/contentscanners
%config(noreplace) %{_sysconfdir}/%{name}/contentscanners/*
%dir %{_sysconfdir}/%{name}/downloadmanagers
%config(noreplace) %{_sysconfdir}/%{name}/downloadmanagers/*
%dir %{_sysconfdir}/%{name}/lists
%config(noreplace) %{_sysconfdir}/%{name}/lists/*
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%attr(755,%{name},%{name}) %dir %{_localstatedir}/log/%{name}
%attr(700,%{name},%{name}) %dir %{_localstatedir}/run/%{name}
%{_sbindir}/clamd.%{name}
%{_unitdir}/clamd.%{name}.service
%ghost %{_localstatedir}/run/%{name}/clamd.sock
%config(noreplace) %{_sysconfdir}/clamd.d/%{name}.conf
%config(noreplace) %{_sysconfdir}/sysconfig/clamd.%{name}


%changelog
* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1.1-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Mon Jun 30 2014 Yaakov Selkowitz <yselkowi@redhat.com> - 2.10.1.1-14
- BR: systemd-units for %%_unitdir (#1106118)

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1.1-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1.1-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1.1-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1.1-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Apr 20 2012 Jon Ciesla <limburgher@gmail.com> - 2.10.1.1-9
- Migrate to systemd, BZ 772064.

* Tue Feb 28 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1.1-8
- Rebuilt for c++ ABI breakage

* Fri Feb 10 2012 Petr Pisar <ppisar@redhat.com> - 2.10.1.1-7
- Rebuild against PCRE 8.30
- Do not check for clamav version
- Fix compilation with GCC 4.7

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1.1-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Sep 30 2009 Steven Pritchard <steve@kspei.com> - 2.10.1.1-4
- Add Fedora clamav package bits to properly integrate

* Thu Sep 10 2009 Felix Kaechele <heffer@fedoraproject.org> - 2.10.1.1-3
- fixes for Bugzilla 515159, 515160, 515161, 515363, 519642, 519976, 520440
- lists now reside in /etc/dansguardian/lists

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.10.1.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul 15 2009 Felix Kaechele <heffer@fedoraproject.org> - 2.10.1.1-1
- news upstream version

* Fri May 29 2009 Felix Kaechele <heffer@fedoraproject.org> - 2.10.0.3-2
- added licensing information

* Sat May 09 2009 Felix Kaechele <heffer@fedoraproject.org> - 2.10.0.3-1
- initial build

